
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Inventory_consumablesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inventory_consumables = await db.inventory_consumables.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        received_quantity: data.received_quantity
        ||
        null
            ,
            
        available_quantity: data.available_quantity
        ||
        null
            ,
            
        shortage: data.shortage
        ||
        null
            ,
            
        last_received_date: data.last_received_date
        ||
        null
            ,
            
        last_issued_date: data.last_issued_date
        ||
        null
            ,
            
        last_supplier: data.last_supplier
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return inventory_consumables;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const inventory_consumablesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                received_quantity: item.received_quantity
            ||
            null
            ,
            
                available_quantity: item.available_quantity
            ||
            null
            ,
            
                shortage: item.shortage
            ||
            null
            ,
            
                last_received_date: item.last_received_date
            ||
            null
            ,
            
                last_issued_date: item.last_issued_date
            ||
            null
            ,
            
                last_supplier: item.last_supplier
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const inventory_consumables = await db.inventory_consumables.bulkCreate(inventory_consumablesData, { transaction });

        // For each item created, replace relation files
        

        return inventory_consumables;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const inventory_consumables = await db.inventory_consumables.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.received_quantity !== undefined) updatePayload.received_quantity = data.received_quantity;
        
        
        if (data.available_quantity !== undefined) updatePayload.available_quantity = data.available_quantity;
        
        
        if (data.shortage !== undefined) updatePayload.shortage = data.shortage;
        
        
        if (data.last_received_date !== undefined) updatePayload.last_received_date = data.last_received_date;
        
        
        if (data.last_issued_date !== undefined) updatePayload.last_issued_date = data.last_issued_date;
        
        
        if (data.last_supplier !== undefined) updatePayload.last_supplier = data.last_supplier;
        
        
        updatePayload.updatedById = currentUser.id;

        await inventory_consumables.update(updatePayload, {transaction});

        
        

        
        

        

        return inventory_consumables;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inventory_consumables = await db.inventory_consumables.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of inventory_consumables) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of inventory_consumables) {
                await record.destroy({transaction});
            }
        });


        return inventory_consumables;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const inventory_consumables = await db.inventory_consumables.findByPk(id, options);

        await inventory_consumables.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await inventory_consumables.destroy({
            transaction
        });

        return inventory_consumables;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const inventory_consumables = await db.inventory_consumables.findOne(
            { where },
            { transaction },
        );

        if (!inventory_consumables) {
            return inventory_consumables;
        }

        const output = inventory_consumables.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inventory_consumables',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.last_supplier) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inventory_consumables',
                        'last_supplier',
                        filter.last_supplier,
                    ),
                };
            }
            

            
            

            
            if (filter.received_quantityRange) {
                const [start, end] = filter.received_quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    received_quantity: {
                    ...where.received_quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    received_quantity: {
                    ...where.received_quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.available_quantityRange) {
                const [start, end] = filter.available_quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    available_quantity: {
                    ...where.available_quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    available_quantity: {
                    ...where.available_quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.shortageRange) {
                const [start, end] = filter.shortageRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    shortage: {
                    ...where.shortage,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    shortage: {
                    ...where.shortage,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.last_received_dateRange) {
                const [start, end] = filter.last_received_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_received_date: {
                    ...where.last_received_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_received_date: {
                    ...where.last_received_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.last_issued_dateRange) {
                const [start, end] = filter.last_issued_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_issued_date: {
                    ...where.last_issued_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_issued_date: {
                    ...where.last_issued_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.inventory_consumables.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'inventory_consumables',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.inventory_consumables.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

